/*
 * MemMon.java
 *
 *  <your company here>, 2003-2007
 * Confidential and proprietary.
 */

import java.io.OutputStream;
import java.util.Date;

import javax.microedition.io.Connector;
import javax.microedition.io.file.FileConnection;

import net.rim.device.api.system.Memory;
import net.rim.device.api.system.MemoryStats;
import net.rim.device.api.ui.MenuItem;
import net.rim.device.api.ui.UiApplication;
import net.rim.device.api.ui.component.RichTextField;
import net.rim.device.api.ui.container.MainScreen;

/**
 * 
 */
class MemMon extends UiApplication {
    private static MemMon theApp;
  private GenericTextDisplayScreen theScreen;
    private Monitor theMonitor;
    MemMon() {
             theScreen = new GenericTextDisplayScreen( "Capturing", "Capturing data..." );
          theMonitor = new Monitor( );
           theMonitor.start();
            synchronized( UiApplication.getEventLock() ) {
                 UiApplication.getUiApplication().pushScreen( theScreen );
              }
      }

     public static void main(String[] args) {
               theApp = new MemMon();
         theApp.enterEventDispatcher();
 }


    public static class GenericTextDisplayScreen extends MainScreen {

             RichTextField field;
           
               public GenericTextDisplayScreen(String title, String text) {
                   super( DEFAULT_MENU | DEFAULT_CLOSE );
                 field = new RichTextField( RichTextField.READONLY );
                   field.setText( text );
                 setTitle( title );
                     add( field );
                  addMenuItem( exitItem );
               }

             public boolean onClose() {
                     UiApplication.getUiApplication().requestBackground();
                  return false;
          }

             private MenuItem exitItem = new MenuItem( "Exit", 10, 1 ) {
                    public void run() {
                            theApp.theMonitor.finished = true;
                             synchronized( theApp.theMonitor ) {
                                    theApp.theMonitor.notify();
                            }
                      }
              };
             
       }

     
       private static class Monitor extends Thread {
          public boolean finished = false;
               long start = 0;
                int iElapsed = 0;
              int t = 0;
             FileConnection fcon;
           OutputStream os;
               byte buf[] = new byte[20];

            public Monitor() {
                     try {
                          fcon = (FileConnection) Connector
                                              .open("file:///SDCard/memstats.csv");
                          if (!fcon.exists()) {
                                  fcon.create();
                         }
                              os = fcon.openOutputStream(fcon.fileSize());
                           os.write( new Date().toString().getBytes() );
                          os.write( ',' );
                               os.write( "Code Alloc,Code Free,Code Obj,Code oSize,Flash Alloc,Flash Free,Flash Obj,Flash oSize,Object Alloc,Object Free,Object Obj,Object oSize,Persistent Alloc,Persistent Free,Persistent Obj,Persistent oSize,RAM Alloc,RAM Free,RAM Obj,RAM oSize,Trans Alloc,Trans Free,Trans Obj,Trans oSize,".getBytes() );
                           os.write( '\r' );
                              os.write( '\n' );
                              
                               start = System.currentTimeMillis();
                    } catch (Exception e) {
                                try { os.close(); } catch( Exception ee ) { }
                          try { fcon.close(); } catch( Exception ee ) { }
                                System.exit(0);
                        }
              }
              public void run() {
                    while( true ) {
                        
                               try {
                                  iElapsed = (int)( (System.currentTimeMillis() - start) / 1000);
                                        t = toByteBuf( buf, iElapsed );
                                        os.write( buf, 0, t );
                                 os.write( ',' );
                                       
                                       for (int i = 0; i < 6; i++) {
                                          MemoryStats stats = null;
                                              switch (i) {
                                                   case 0 :
                                                               stats = Memory.getCodeStats();
                                                         break;
                                                 case 1 :
                                                               stats = Memory.getFlashStats();
                                                                break;
                                                 case 2 :
                                                               stats = Memory.getObjectStats();
                                                               break;
                                                 case 3 :
                                                               stats = Memory.getPersistentStats();
                                                           break;
                                                 case 4 :
                                                               stats = Memory.getRAMStats();
                                                          break;
                                                 case 5 :
                                                               stats = Memory.getTransientStats();
                                                            break;
                                         }
                                                      
                                               t = toByteBuf( buf, stats.getAllocated() );
                                            os.write( buf, 0, t );
                                         os.write( ',' );
                                               
                                               t = toByteBuf( buf, stats.getFree() );
                                         os.write( buf, 0, t );
                                         os.write( ',' );
       
                                               t = toByteBuf( buf, stats.getObjectCount() );
                                          os.write( buf, 0, t );
                                         os.write( ',' );
       
                                               t = toByteBuf( buf, stats.getObjectSize() );
                                           os.write( buf, 0, t );
                                         os.write( ',' );
       
                                       }
                                      os.write( '\r' );
                                      os.write( '\n' );
                                      os.flush();
                                    
       
                               }
                              catch( Exception e ) {
                                 try { os.close(); } catch( Exception ee ) { }
                                  try { fcon.close(); } catch( Exception ee ) { }
                                        System.exit( 0 );
                              }
                              
                               if( finished ) {
                                       try { os.close(); } catch( Exception ee ) { }
                                  try { fcon.close(); } catch( Exception ee ) { }
                                        System.exit( 0 );
                              }
                              synchronized( this ) {
                                 try {
                                          this.wait( 300000 ); //5 min
                                   }
                                      catch( Exception e ) { }
                               }
                              if (finished) {
                                        try { os.close(); } catch( Exception e ) { }
                                   try { fcon.close(); } catch( Exception e ) { }
                                 System.exit(0);
                                }
                      }
                      
               }
      }
      final static byte[] digits = {'0', '1', '2', '3', '4', '5', '6', '7', '8',
                     '9', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l',
                       'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y',
                       'z'};
  final static byte[] DigitTens = {'0', '0', '0', '0', '0', '0', '0', '0',
                       '0', '0', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '2',
                       '2', '2', '2', '2', '2', '2', '2', '2', '2', '3', '3', '3', '3',
                       '3', '3', '3', '3', '3', '3', '4', '4', '4', '4', '4', '4', '4',
                       '4', '4', '4', '5', '5', '5', '5', '5', '5', '5', '5', '5', '5',
                       '6', '6', '6', '6', '6', '6', '6', '6', '6', '6', '7', '7', '7',
                       '7', '7', '7', '7', '7', '7', '7', '8', '8', '8', '8', '8', '8',
                       '8', '8', '8', '8', '9', '9', '9', '9', '9', '9', '9', '9', '9',
                       '9',};
 final static byte[] DigitOnes = {'0', '1', '2', '3', '4', '5', '6', '7',
                       '8', '9', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0',
                       '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '1', '2', '3',
                       '4', '5', '6', '7', '8', '9', '0', '1', '2', '3', '4', '5', '6',
                       '7', '8', '9', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
                       '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '1', '2',
                       '3', '4', '5', '6', '7', '8', '9', '0', '1', '2', '3', '4', '5',
                       '6', '7', '8', '9', '0', '1', '2', '3', '4', '5', '6', '7', '8',
                       '9',};

        public static int toByteBuf(byte buf[], int i) {
               int size = (i < 0) ? stringSize(-i) + 1 : stringSize(i);
               getChars(i, size, buf);
                return size;
   }
      /**
     * Places characters representing the integer i into the character array
        * buf. The characters are placed into the buffer backwards starting with
       * the least significant digit at the specified index (exclusive), and
  * working backwards from there.
        * 
     * Will fail if i == Integer.MIN_VALUE
  */
    static void getChars(int i, int index, byte[] buf) {
           int q, r;
              int charPos = index;
           byte sign = 0;
         if (i < 0) {
                   sign = '-';
                    i = -i;
                }
              // Generate two digits per iteration
           while (i >= 65536) {
                   q = i / 100;
                   // really: r = i - (q * 100);
                  r = i - ((q << 6) + (q << 5) + (q << 2));
                      i = q;
                 buf[--charPos] = DigitOnes[r];
                 buf[--charPos] = DigitTens[r];
         }
              // Fall thru to fast mode for smaller numbers
          // assert(i <= 65536, i);
              for (;;) {
                     q = (i * 52429) >>> (16 + 3);
                  r = i - ((q << 3) + (q << 1)); // r = i-(q*10) ...
                     buf[--charPos] = digits[r];
                    i = q;
                 if (i == 0)
                            break;
         }
              if (sign != 0) {
                       buf[--charPos] = sign;
         }
      }
      final static int[] sizeTable = {9, 99, 999, 9999, 99999, 999999, 9999999,
                      99999999, 999999999, Integer.MAX_VALUE};
       // Requires positive x
 static int stringSize(int x) {
         for (int i = 0;; i++)
                  if (x <= sizeTable[i])
                         return i + 1;
  }

}
